#include  <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

/* max liczba utworzonych watkow */
#define MAX 4

/* Funkcja. ktora bedzie wykonywal kazdy watek */
void * watek(void *);

int main ()
{
   int i;

   /* Identyfikatory watkow beda w tej tablicy */  
   pthread_t thread_id[MAX];   

   /* adres komorki pamieci, w ktorej bedzie
      przechowywane to, co zwroci nam funkcja 
      watkowa (wskaznik na to)
   */
   int status, *p_status=&status;
  
   /* Tablica posiadajaca tyle elementow, ile 
      jest watkow
   */
   int numer[MAX];

   /* wypelnienie tej tablicy wartosciami niezerowymi */
   for(i=0; i<MAX;i++) 
      numer[i]=i+1;

   /* Tworzenie watkow 
      kolejno argumenty:
      - identyfikator watku (ta f-cja zwraca te wartosc
        po utworzeniu watku
      - zestaw argumentow dla watku, tu: domyslne
      - funkcja wykonywana w ramach watku (musi byc void,
        dlatego na poczatku, przy daklaracji bylo
        tzw. rzutowanie)
      - argumenty tej funkcji (tez void - rzutwany)
   */
   printf("Tworze watki");
   for(i=0; i<MAX; i++)
   {
      if (pthread_create(&thread_id[i],NULL,watek,(void *) &numer[i])>0)
      {
         fprintf (stderr, "\n Niepowodzenie: pthread_create \n");
         exit(1);
      }
   }
  
   /* Wcielanie watkow - koniec dzialania watkow */
   for(i=0; i<MAX; i++)
   {
      if (pthread_join(thread_id[i],(void * *) p_status)>0)
      {
         fprintf (stderr, "\n Niepowodzenie: pthread_join \n");
         exit(2);
      }
   }	
  
   printf ("\n Koniec.\n');
   return (void *) NULL;

}

/* Funkcja, ktora bedza realizowac watki 
   Nie do koncapawda, ze te watki sa tu
   powolywane do zycia !!!
*/

void *watek (void *num)
{
   int numer=*num;
   printf("\n Watek %d zostal powolany do zycia.",numer);
   sleep(1);
   printf("\n Watek %d konczy sie",numer);
}