/*--------------  tworzenie roznych semaforow  ---------------*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <unistd.h>


/*
Nie uzyto funkcji Init_Semafora, zeby moc wyswietlic rozne komunikaty
przy blednym dzialanie getsem,
mozna jej uzyc, ale komunikat o bledzie po polsku trzeba by sparametryzowac.
*/

main (void)
{
	int    semafor1, semafor2, semafor3;
	key_t  klucz_semafora;

	/* uzyskujemy klucz semafora */
	klucz_semafora = ftok (".", 'S');

	/*
	   tworzymy 1-szy zest. semaforow i sprawdzamy, jak sie utworzyl
	   ilosc sem. w zestawie, warunki tworzenia sem | prawa dostepu
	*/
	semafor1 = semget (klucz_semafora, 3, IPC_CREAT | 0666);
	/* jesli utworzenie semafora zakonczylo sie bledem */
	if (semafor1 == -1)
	{
		perror ("Blad tworzenia semafora 1 o nastepujacych warunkach i prawach: \n IPC_CREAT | 0666");
	}
	printf ("\n Identyfikator semafora 1 : %d \n", semafor1);

	/*
	   tworzymy 2-gi zest. semaforow i sprawdzamy, jak sie utworzyl
	   dla takiego samego klucza jak poprzedni zestaw semaforow,
	   dodatkowo zawiera stala IPC_EXCL. Jesli utworzenie poprzedniego
	   zestawu semaforow zakonczylo sie sukcesem - to to nie ma prawa
	   sie wykonac prawidlowo !
	 */
	semafor2 = semget (klucz_semafora, 3, IPC_CREAT | IPC_EXCL | 0666);
	/* jesli utworzenie semafora zakonczylo sie bledem */
	if (semafor2 == -1)
	{
		perror ("Blad tworzenia semafora 2 o nastepujacych warunkach i prawach: \n IPC_CREAT | IPC_EXCL | 0666");
	}
	printf ("\n Identyfikator semafora 2 : %d \n", semafor2);

	/*
	   tworzymy 3-ci zest. semaforow i sprawdzamy, jak sie utworzyl
	   zestaw semaforow prywatny dla danego procesu !!!
	*/
	semafor3 = semget (IPC_PRIVATE, 3, 0600);
	/* jesli utworzenie semafora zakonczylo sie bledem */
	if (semafor3 == -1)
	{
		perror ("Blad tworzenia semafora 3 o nastepujacych warunkach i prawach: \n 0600 i o kluczu IPC_PRIVATE");

	}

	printf ("\n Identyfikator semafora 3 : %d \n", semafor3);
}